#ifndef _H_LIBCX_IO_PRINT
#define _H_LIBCX_IO_PRINT

#include <cx/io/stdout.hpp>
#include <cx/string.hpp>
#include <cx/stl.hpp>
#include <cx/format/fmt.hpp>

template <typename... Types>
void print(const char* fmt, Types... args) {
    String s = format(fmt, args...);
    Stdout<String>::write(stl::move(s));
}

template <typename... Types>
void println(const char* fmt, Types... args) {
    print(fmt, args...);
    Stdout<String>::write(String("\n"));
}

#endif // !_H_LIBCX_IO_PRINT