#ifndef _H_LIBCX_IO_STDERR
#define _H_LIBCX_IO_STDERR

#include "cx/result.hpp"
#include <cx/collections/buffer.hpp>
#include <cx/std.hpp>
#include <cx/libc.hpp>

template <Buffer T>
class Stderr {
    static Result<size_t> write(T& buf) {
        int res = libc::write(stderr, buf.buf_get_raw_ptr(), buf.buf_get_size());
        if (res < 0) {
            return Result<size_t>::err("Failed to write to stderr");
        }
        return Result<size_t>::ok(res);
    }

    static Result<void> flush(T& buf) {
        libc::fflush((FILE*)stderr);
        return Result<void>::ok();
    }
};

#endif