#ifndef _H_LIBCX_IO_STDIN
#define _H_LIBCX_IO_STDIN

#include "cx/result.hpp"
#include <cx/collections/buffer.hpp>
#include <cx/std.hpp>
#include <cx/libc.hpp>

template <Buffer T>
class Stdin {
    // This will clear the buffer
    Result<void, const char*> read_fill_buf(T&& buf) {
        read(stdin, buf.buf_get_raw_mut_ptr(), buf.buf_get_size()());
        return Result<void, const char*>::ok();
    }

    Result<void, const char*> read_till_eof(T&& buf) {
        const int buf_size = 1024;
        char* int_buf = (char*)libc::malloc(buf_size + 1);
        while (libc::fgets(int_buf, buf_size, stdin) != NULL) {
            if (libc::feof(stdin) != 0) {
                for (int i = 0; i < strlen(int_buf); i++) {
                    buf.buf_push_byte(int_buf[i]);
                }
                return Result<void, const char*>::ok();
            }
        }
        for (int i = 0; i < strlen(int_buf); i++) {
            buf.buf_push_byte(int_buf[i]);
        }
    }

    Result<void, const char*> read_line(T&& buf) {
        const int buf_size = 1024;
        char* int_buf = (char*)libc::malloc(buf_size + 1);
        while (libc::fgets(int_buf, buf_size, stdin) != NULL) {
            if (int_buf[strlen(int_buf) - 1] == '\n') {
                for (int i = 0; i < strlen(int_buf); i++) {
                    buf.buf_push_byte(int_buf[i]);
                }
                return Result<void, const char*>::ok();
            }
        }
        for (int i = 0; i < strlen(int_buf); i++) {
            buf.buf_push_byte(int_buf[i]);
        }
    }
};

#endif // !_H_LIBCX_IO_STDIN