#ifndef _H_LIBCX_IO_STDOUT
#define _H_LIBCX_IO_STDOUT

#include "cx/result.hpp"
#include <cx/collections/buffer.hpp>
#include <cx/libc.hpp>

template <Buffer T>
class Stdout {
public:
    static Result<size_t> write(T&& buf) {
        int res = libc::write(stdout, buf.buf_get_raw_ptr(), buf.buf_get_size());
        if (res < 0) {
            return Result<size_t>::err("Failed to write to stdout");
        }
        return Result<size_t>::ok(res);
    }

    static Result<void> flush(T&& buf) {
        libc::fflush((FILE*)stdout);
        return Result<void>::ok();
    }
};

#endif