#ifndef _H_CX_STL_IS_UNSIGNED
#define _H_CX_STL_IS_UNSIGNED
#if __has_builtin(__is_unsigned)

#include <cx/stl/integral_constant.hpp>
#include <cx/stl/is_integral.hpp>

template <class _Tp>
struct is_unsigned : _BoolConstant<__is_unsigned(_Tp)> {};

template <class _Tp>
inline constexpr bool is_unsigned_v = __is_unsigned(_Tp);

#else // __has_builtin(__is_unsigned)

template <class _Tp, bool = is_integral<_Tp>::value>
inline constexpr bool __is_unsigned_v = false;

template <class _Tp>
inline constexpr bool __is_unsigned_v<_Tp, true> = _Tp(0) < _Tp(-1);

template <class _Tp>
struct is_unsigned : integral_constant<bool, __is_unsigned_v<_Tp>> {};

template <class _Tp>
inline constexpr bool is_unsigned_v = __is_unsigned_v<_Tp>;

#endif // __has_builtin(__is_unsigned)
#endif // !_H_CX_STL_IS_UNSIGNED