#ifndef _H_LIBCX_STRING
#define _H_LIBCX_STRING

#include <cx/collections/vec.hpp>

class String {
private:
    Vec<char> _chars;

public:
    String() = default;
    ~String() = default;
    String(const char*);
    size_t len();
    void clear();
    Vec<char>& chars();
    char* const as_cstr();
    void push(char c);
    void push_str(String& str);
    // void push_str(String&& str);
    void push_str(const char* str);
    // IMPL: Format
    String fmt_to_str();
    // IMPL: Clone
    String clone();
    // IMPL: Buffer
    uint8_t const* buf_get_raw_ptr();
    // IMPL: Buffer
    uint8_t* buf_get_raw_mut_ptr();
    // IMPL: Buffer
    size_t buf_get_size();
    // IMPL: Buffer
    void buf_push_byte(uint8_t byte);
    // IMPL: Buffer
    void buf_append_bytes(uint8_t const* byte_ptr, size_t byte_count);
};

#endif // _H_LIBCX_STRING